.386
.model flat,stdcall
option casemap:none

include MailLog.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName, NULL
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		; Register my buttons and the like
		invoke	GetDlgItem, hWnd, IDC_MAIL
		mov		hMailButton, eax
		invoke	GetDlgItem, hWnd, IDC_EXIT
		mov		hExitButton, eax
		invoke	GetDlgItem, hWnd, IDC_CONSOLE
		mov		hConsole, eax
		invoke	GetDlgItem, hWnd, IDC_SEND
		mov		hMailSend, eax
		
		; All mail funtions live in a Dynamic Link Library called MAPI32.DLL. 
		; I need to load the library into memory so I can use the procedures.

		invoke	LoadLibrary, addr MailDLL
		.if (eax)																; if the load was successfull  
			mov		hMailDLL, eax												; save off the handle of the DLL 
			invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr DLLwin 			; display a message
			invoke	GetProcAddress, hMailDLL, addr mLogon						; now get the process address from DLL
			.if (eax)							
				mov	hmLogon, eax												; if successful, save the adresss
				invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr ProcWin 
			.else																; We could not load the proc address
				invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr ProcErr
			.endif
		.else																	; We could not load the DLL
			invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr DLLerr
		.endif 
		
		; Display a message saying that we are ready to connect
		invoke	SendMessage, hConsole, EM_SETSEL, -1, -1	 					; move cursor to the end of the text
		invoke	SendMessage, hConsole, EM_REPLACESEL, FALSE, addr WelcomeMsg	; append my message 
		invoke	SendMessage, hConsole, EM_SCROLLCARET, NULL, NULL  				; scroll window
		
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDC_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDC_MAIL
			invoke	MAPILogon,0 , hWnd, NULL, NULL, MAPI_LOGON_UI, hMailSession
			.if (eax)
				invoke MessageBox, hWnd, addr AboutMsg, addr MailLogWin, MB_OK
			.endif
			; Log onto the mail server, the address of the external procedure is contained in hmLogon, first push the 
			; parameters onto the stack...
			
			;push	0						; UIParam, either 0 or the handle of the controling windows
			;push	0						; lpszProfileName
			;push 	0						; lpszPassword
			;push	offset MAPI_LOGON_UI	; flFlags
			;push	0						; ulReserved
			;push	offset hMailSession		; lplhSession
			;call	DWORD PTR [hmLogon]
			
			;.if(eax != SUCCESS_SUCCESS)
		;		invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr MailLogErr 
		;	.else
		;		invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr MailLogWin
		;	.endif 
			 
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
